/**
 * Generate unconnected graphs
 * i.e. graphs with no edge
 */
package helix.graph.algo;

import helix.graph.model.Graph;
import helix.graph.model.GraphFactory;

public class BasicGenerator implements Generator {

	protected int nbVertices_;
	
	public BasicGenerator(int nbVertices) {
		if (nbVertices < 0)
			throw new IllegalArgumentException("nbVertices should be >= 0");
		nbVertices_ = nbVertices;
	};
	
	public Graph generate(GraphFactory factory) {
		Graph g = factory.make();
    	for (int i = 0; i < nbVertices_ ; i++) {
    		g.addVertex();
    	}
		return g;
	}

}
