/**
 * Generate graphs with circle (chain) topology
 */

package helix.graph.algo;

import java.util.Iterator;

import helix.graph.model.Graph;
import helix.graph.model.GraphFactory;
import helix.graph.model.Vertex;

public class CircleGenerator extends BasicGenerator {

	public CircleGenerator(int nbVertices) {
		super(nbVertices);
	}
	
	public Graph generate(GraphFactory factory) {
		// make vertices
		Graph g = super.generate(factory);
		// add edges
		Iterator<Vertex> it = g.vertices().iterator();
		Vertex v0, v1;
		v0 = v1 = (it.hasNext() ? it.next() : null);
		while (it.hasNext()) {
			Vertex v2 = it.next();
			g.addEdge(v1, v2);
			v1 = v2;
		}
		// close circle
		if (v0 != v1) {
			g.addEdge(v0, v1);
		}
		return g;
	}
}
