package helix.graph.algo;

import java.util.Set;

import helix.graph.model.GSet;
import helix.graph.model.Graph;
import helix.graph.model.Vertex;

/**
 * a class to compute connected components.
 * this class is obsolete, please consider using the CCVisitor class instead.
 * 
 * @see : CCVisitor provides a more general and extendable mechanism to collect CC.
 * 
 */
public class ComponentsFinder {

	private static final String Visited = "_ComponentFinder_Visited_";
	
	protected Graph graph_;

	/**
	 * recursively add v component into connected component set cc
	 */
	protected static final void component_(Vertex v, GSet<Vertex> cc) {
		if (v.has(Visited))
			return;
		v.set(Visited);
		cc.add(v);
		for (Vertex u : v.neighbors()) {
			component_(u, cc);
		}
	}
	
	/**
	 * cleanup flags
	 */
	protected static final void removeFlags_(Iterable<Vertex> set) {
		for (Vertex v : set) {
			v.remove(Visited);
		}
	}
	
	
	/*
	 * API
	 */
	
	/**
	 * constructor
	 */
	
	public ComponentsFinder(Graph g) {
		graph_ = g;
	}
	
	/**
	 * return component containing vertex v
	 */
	
	public GSet<Vertex> component(Vertex v) {
		GSet<Vertex> cc = graph_.vertexSetFactory().make();
		component_(v, cc);
		removeFlags_(cc);
		return cc;
	}

	/**
	 * return all connected components of graph 
	 */
	
	public Set<GSet<Vertex>> connectedComponents() {
		Set<GSet<Vertex>> partition = graph_.vertexSetFactory().makeSuper();
		for (Vertex v : graph_.vertices()) {
			if (v.has(Visited))
				continue;
			partition.add(component(v));
		}
		removeFlags_(graph_.vertices());
		return partition; 
	}
	
}
