/**
 * Generate graphs with star topology
 *   
 */

package helix.graph.algo;

import java.util.Iterator;

import helix.graph.model.Graph;
import helix.graph.model.GraphFactory;
import helix.graph.model.Vertex;

public class StarGenerator extends BasicGenerator {

	public StarGenerator(int nbVertices) {
		super(nbVertices);
	}
	
	public Graph generate(GraphFactory factory) {
		Graph g = super.generate(factory);
		// add edges
		Iterator<Vertex> it = g.vertices().iterator();
		Vertex v0 = (it.hasNext() ? it.next() : null);
		while (it.hasNext()) {
			Vertex v1 = it.next();
			g.addEdge(v0, v1);
		}
		return g;
	}
}
