package helix.graph.algo;

import helix.graph.model.Edge;
import helix.graph.model.Vertex;

public interface Visitor {

	public Visitor traverse();		// start traversal (return this for piping)
	
	public void visit(Vertex v);	// visit a vertex
	
	public boolean accept(Edge e);	// tells if edge is acceptable
	
	public void enter();			// enter a new visit
	public void exit();				// exit a new visit
}
