package helix.graph.algo.c3part.compressor;

import helix.graph.model.Vertex;
import helix.graph.model.impl.RColorSet;

/**
 * A multigraph compressor is graph compressor for multigraphs.
 * this extends the GraphCompressor interface with specific
 * methods to deal with colors of edges.
 */
public interface MultiGraphCompressor extends GraphCompressor {

	/*
	 * Generic API
	 */

	/**
	 * get proper colors of edge (v, u).
	 * return empty colors if there is no edge
	 */
	public RColorSet getColors(Vertex v, Vertex u);
}
