package helix.graph.algo.c3part.lookahead;

/**
 * an abstract lookahead connector that work on all datanodes of the current multigraph
 * (i.e. not only terminals)
 */

import helix.graph.algo.c3part.C3PartUtil;
import helix.graph.model.GSet;
import helix.graph.model.Graph;
import helix.graph.model.Vertex;
import helix.graph.model.impl.RColorSet;

public abstract class ExtendedConnector extends LookaheadConnector {

	/**
	 * @Implement
	 * get all latest vertices in multigraph (except stars)
	 */
	protected GSet<Vertex> getConnectors(Graph multigraph) {
		GSet<Vertex> connectors = multigraph.vertexSetFactory().make();
		for (Vertex V : multigraph.vertices()) {
			for (Vertex v : C3PartUtil.getNodes(V))
				if (! RColorSet.getColors(v).isEmpty()) { // i.e no star
					connectors.add(v);
				}
		}
		return connectors;
	}
}
