package helix.graph.algo.c3part.optimizer;

/**
 * color optimizer that does not optimize anything 
 * just yield colors in the order specified as arguments.
 *
 */

import helix.graph.util.IPermutation;

import java.util.Iterator;

public class FixColorOptimizer extends AbstractColorOptimizer {

	private String preview_;
	
	protected Iterator<Integer> iterator_;
	
	// just a preview for toString()
	//
	private final void makePreview_(Iterable<Integer> colors) {
		StringBuffer buffer = new StringBuffer();
		for (int color : colors) {
			buffer.append(" " + color);
		}
		preview_ = "[" + buffer.substring(1) + "]";
	}
	
	public FixColorOptimizer(Iterable<Integer> colors) {
		iterator_ = new IPermutation(colors).iterator();
		makePreview_(colors);
	}

	public boolean hasNext() {
		return iterator_.hasNext();
	}


	public Integer next() {
		int color = iterator_.next();
		this.storeColor_(color);
		return color;
	}
	
	@Override
	/**
	 * preview
	 */
	public String preview() {
		return preview_;
	}

	/**
	 * human readable version
	 */
	public String toString() {
		return preview_;
	}

	
}
