package helix.graph.algo.c3part.optimizer;

import java.util.NoSuchElementException;

/**
 * color optimizer that does not optimize anything 
 * just return Identity (iterator over integer : 1, 2, ..., nbColors)
 *
 */
public class IdentityColorOptimizer extends AbstractColorOptimizer {

	protected int maxIndex_;
	protected int currentIndex_ = 0;

	/**
	 * constructor
	 */
	public IdentityColorOptimizer(int nbColors) {
		maxIndex_ = nbColors;
	}
	
	/**
	 * hasNext 
	 */
	public boolean hasNext() {
		return (currentIndex_ < maxIndex_);
	}

	/**
	 * next
	 */
	public Integer next() {
		if (! hasNext())
			throw new NoSuchElementException();
		currentIndex_++;
		this.storeColor_(currentIndex_);
		return currentIndex_;
	}

	@Override
	/**
	 * preview
	 */
	public String preview() {
		StringBuffer buffer = new StringBuffer();
		for (int i = 1 ; i <= maxIndex_ ; i++)
			buffer.append(" " + i);
		return "[" + buffer.substring(1) + "]";
	}
	
	@Override
	/**
	 * human readable version
	 */
	public String toString() {
		return this.preview();
	}
}
