package helix.graph.algo.c3part.reporter;

/**
 * this class provides utilities for all subsequent reporters
 */

import helix.graph.model.Registry;
import helix.graph.model.impl.RColorSet;
import helix.graph.util.Reporter;

public abstract class BaseReporter extends Reporter {

	/**
	 * an empty RColorSet
	 */ 
	protected static RColorSet noColor_ = new RColorSet();

	/**
	 * get String value of registry
	 */
	protected static String getRegistryValue_(Registry r, String key, String dft) {
		String s = (r.has(key) ? r.get(key).toString() : dft);
		return s.replace("\"", "");
	}
	
	/**
	 * get RColorSet of registry
	 */
	protected static RColorSet getColors_(Registry r) {
		return (r.has(Registry.Colors) ? (RColorSet) r.get(Registry.Colors) : noColor_);
	}

	/**
	 * get single color of registry
	 * note: return -1 if no color
	 */
	protected static int getColor_(Registry r) {
		RColorSet colors = getColors_(r);
		return (colors.countColors() == 1 ? colors.singleColor() : -1);
	}
	
}
