package helix.graph.algo.c3part.visitor;

/**
 * a Visitor to compute CC of a multigraph by following 
 * edges having the specified color.
 */

import helix.graph.model.Edge;
import helix.graph.model.Graph;
import helix.graph.model.impl.RColorSet;

public class CCByColorVisitor extends CCMultigraphVisitor {

	protected int color_;

	public CCByColorVisitor(Graph multigraph, int color) {
		super(multigraph);
		color_ = color;
	}

	@Override
	/**
	 * override accept to select on the edge color
	 */
	public boolean accept(Edge e) {
		return RColorSet.hasColor(e, color_);
	}
}
