package helix.graph.algo.c3part.visitor;

/**
 * a datagraph CC Visitor returning CC by colors (i.e primary graphs) 
 */
import helix.graph.model.Edge;
import helix.graph.model.Graph;
import helix.graph.model.impl.RColorSet;

public class CCByColorsVisitor extends CCDatagraphVisitor {

	public CCByColorsVisitor(Graph datagraph) {
		super(datagraph);
	}

	@Override
	/**
	 * override default accept to accept edges of the same color
	 */
	public boolean accept(Edge e) {
		int c1 = RColorSet.getColors(e.v1()).singleColor();
		int c2 = RColorSet.getColors(e.v2()).singleColor();
		return (c1 == c2);
	}
}
