package helix.graph.algo.c3part.visitor;

import helix.graph.model.GSet;
import helix.graph.model.Graph;
import helix.graph.model.Vertex;

/**
 * the superstar version of CCStarByColorVisitor
 *
 * -1- keep red stars apart (red star is a vertex having a star on specified color)
 * -2- compute normal CCs
 * -3- fadd red stars as a separate CC
 */

public class CCSuperStarByColorVisitor extends CCStarByColorVisitor {

	public CCSuperStarByColorVisitor(Graph multigraph, int color, int colorIndex, Vertex star) {
		super(multigraph, color, colorIndex, star);
	}

	public Iterable<GSet<Vertex>> getComponents() {

		// just add redstars as a separate cc
		//
		if (redStars_.size() != 0) {
			cc_.add(redStars_);
		}
		
		return cc_;
	}
}
