package helix.graph.model;

import java.util.Set;
/**
 *
 * @param <E>
 */
public interface GSet<E extends GraphElement> extends Set<E> {

	public static final String RehashKey = "_GSetRehashKey_";

	public GSetFactory<E> factory();

	public void addIterable(Iterable<E> e);
	
	public E findUnique(String registryKey, RegistryValue registryValue)
	  throws DuplicateValueException;

	public E findUnique(String registryKey, Object anyValue)
	  throws DuplicateValueException;

	public GSet<E> findMultiple(String registryKey, RegistryValue registryValue);

	public GSet<E> findMultiple(String registryKey, Object anyValue);
}
