package helix.graph.model;


/**
 * A Registry keeps pairs of (key, value)
 * key   : String
 * value : RegistryValue
 *
 */

public interface Registry {

	//
	// some reserved keys for Registry
	// these keys are understood by IO readers
	//
	
	//
	// [AV] : should be put to another place : RegistryUtils
	//
	
	// registry label
	public static final String Label = "Label";
	
	// registry comment
	public static final String Comment = "Comment";
	
	// for colored graph (backward compatibility)
	public static final String Colors = "Colors";

	// for colored graph (new preferred foramt)
	public static final String Color = "Color";
	
	// for gene position rank (optional)
	public static final String Rank = "Rank";

	// for gene strand orientation (optional)
	public static final String Orientation = "Orientation";
	public static final String IsDirect = "isDirect";

	/*
	 * API
	 */
	
	public Registry registry(); // look strange but correct
	
	public boolean has(String key);
	
	public RegistryValue get(String key);

	public void set(String key, RegistryValue value);

	public void set(String key); // AV added (for simple flags)

	public void remove(String key);
	
	public Iterable<String> keys();
	
	public void copy(Registry source);

	
	/*
	 * helper methods
	 */

	public void set(String key, String value);
	public void set(String key, int value);
	public void set(String key, float value);
	public void set(String key, boolean value);
	
}
