package helix.graph.model.impl;

/*
 * Abstract GSetFactory implementation
 * provides basic operations in order to minimize your implementation
 */

import helix.graph.model.GSet;
import helix.graph.model.GSetFactory;
import helix.graph.model.GraphElement;

public abstract class AbstractGSetFactory<E extends GraphElement> implements GSetFactory<E> {

	public GSet<E> make(Iterable<E> elements) {
		GSet<E> set = this.make();
		set.addIterable(elements);
		return set;
	}
}
