package helix.graph.model.impl;

import helix.graph.model.Registry;

public abstract class AbstractRegistry implements Registry {
	
	/*
	 * default registry
	 */
	
	public Registry registry() {
		return this;
	}

	/*
	 * default Registry API
	 */
	
	public void copy(Registry src) {
		for (String key : src.keys()) {
			if (! key.startsWith("_")) { // AV : added : don't copy internal keys
			   this.set(key, src.get(key).klone());
			}
		}
	}
	
	/*
	 * helper methods
	 */
	public void set(String key) {
		this.set(key, new RVoid());
	}

	public void set(String key, String value) {
		this.set(key, new RString(value));
	}

	public void set(String key, int value) {
		this.set(key, new RInteger(value));
	}
	
	public void set(String key, float value) {
		this.set(key, new RFloat(value));
    }
	
	public void set(String key, boolean value) {
		this.set(key, new RBoolean(value));
	}
}
