package helix.graph.model.impl;

import helix.graph.model.IllegalValueException;
import helix.graph.model.RegistryValue;

/**
 * an abstract implmentation of Registrable, providing
 * basic mechanisms.
 *
 */
public abstract class AbstractRegistryValue implements RegistryValue {

	/*
	 * Basic implementations, you may override them 
	 */
	
	/*
	 * default serialize is equivalent to toString()
	 */
	
	public String serialize() {
		return this.toString();
	}

	/*
	 * default type converters
	 */
	
	public int toInt() throws IllegalValueException {
		try {
			return Integer.parseInt(this.toString());
		}
		catch (NumberFormatException nfe) {
			throw new IllegalValueException(nfe);
		}
	}

	public float toFloat() throws IllegalValueException {
		try {
			return Integer.parseInt(this.toString());
		}
		catch (NumberFormatException nfe) {
			throw new IllegalValueException(nfe);
		}
	}

	public boolean toBoolean() {
		return Boolean.parseBoolean(this.toString());
	}

}
