package helix.graph.model.impl;

import helix.graph.model.RegistryValue;
import helix.graph.model.Registry;

public abstract class DelegateRegistry extends AbstractRegistry {
	
	public abstract Registry registry();
	
	public boolean has(String key) {
		return this.registry().has(key);
	}

	public RegistryValue get(String key) {
		return this.registry().get(key);
	}

	public void set(String key, RegistryValue value) {
		this.registry().set(key, value);
	}

	public void remove(String key) {
		this.registry().remove(key);
	}

	public Iterable<String> keys() {
		return this.registry().keys();
	}
}
