package helix.graph.model.impl;

import helix.graph.model.RegistryValue;

/**
 * an AbstractRegistrable for Immutable objects
 *
 */
public abstract class ImmutableRegistryValue extends AbstractRegistryValue {

	public RegistryValue klone() {
		return this;
	}

	/*
	 * defaut hashcode and equals for immutable values
	 */
	
	/**
	 * Compares this RegistryValue to the specified object. 
	 * The result is true if and only if the argument is not null and is 
	 * a RegistryValue object that has the same serialization.
	 * This allows different basic types representing the same value
	 * to be considered as equals.
	 */
	
	public boolean equals(Object o) {
		return (  (o instanceof RegistryValue)
			    ? this.serialize().equals(((RegistryValue) o).serialize())
				: false);
	}

	/**
	 * Returns a hash code for this RegistryValue
	 * equals to serialize().hashcode();
	 */
	public int hashCode() {
		return this.serialize().hashCode();
	}
	
	
}
