package helix.graph.model.impl;

import helix.graph.model.IllegalValueException;

public class RFloat extends ImmutableRegistryValue {

	protected float value_;

	public RFloat(float f) {
		this.value_ = f;
	}

	public RFloat(Float f) {
		this(f.floatValue());
	}

	public RFloat(String s) throws IllegalValueException {
	  try {
	    this.value_ = Float.parseFloat(s);
	  }
	  catch (NumberFormatException nfe) {
		throw new IllegalValueException(nfe);
	  }
	}
	
	//@override
	public String toString() {
		return Float.toString(this.value_);
	}
	
	//@override
	public int toInt() {
		return Math.round(this.value_);
	}

	//@override
	public float toFloat() {
		return this.value_;
	}

	//@override
	public boolean toBoolean() {
		return (this.value_ != 0f);
	}

}
