package helix.graph.model.impl;

import helix.graph.model.IllegalValueException;

public class RInteger extends ImmutableRegistryValue {

	protected int value_;

	public RInteger(int i) {
		this.value_ = i;
	}

	public RInteger(Integer i) {
		this(i.intValue());
	}

	public RInteger(String s) throws IllegalValueException {
	  try {
	    this.value_ = Integer.parseInt(s);
	  }
	  catch (NumberFormatException nfe) {
		throw new IllegalValueException(nfe);
	  }
	}
	
	//@override
	public String toString() {
		return Integer.toString(this.value_);
	}
	
	//@override
	public int toInt() {
		return this.value_;
	}

	//@override
	public float toFloat() {
		return (float) this.value_;
	}

	//@override
	public boolean toBoolean() {
		return (this.value_ != 0);
	}
	
}
