package helix.graph.model.impl;

import helix.graph.model.IllegalValueException;
import helix.graph.model.RegistryValue;
import helix.graph.model.Vertex;

/**
 * a memory implementation of a RegistryValue to hold a single Vertex
 * @author viari
 *
 */
public class RVertex implements RegistryValue {

	protected Vertex vertex_;

	public RVertex(Vertex v) throws IllegalValueException {
		this.set(v);
	}
	
	// API

	// klone : duplicate instance for safety
	
	public RegistryValue klone() {
		return new RVertex(this.vertex_);
	}

	public String serialize() {
		throw new IllegalValueException();
	}

	public boolean toBoolean() throws IllegalValueException {
		throw new IllegalValueException();
	}

	public float toFloat() throws IllegalValueException {
		throw new IllegalValueException();
	}

	public int toInt() throws IllegalValueException {
		throw new IllegalValueException();
	}
	
	// equals and hashcode
	
	public boolean equals(Object o) { 
		return (  (o instanceof RVertex)
			    ? vertex_.equals(((RVertex) o).vertex_)
				: false);
	}

	public int hashCode() {
		return vertex_.hashCode();
	}

	// added functions
	
	public Vertex get() {
		return vertex_;
	}

	public Vertex set(Vertex v) throws IllegalValueException {
		if (v == null) 
			throw new IllegalValueException();
		vertex_ = v;
		return vertex_;
	}

	/**
	 * a human readable version of toString()
	 */
	public String toString() {
		return "RVertex[" + vertex_.toString() + "]";
	}
	
	
	
}
