package helix.graph.model.impl.memory;

import helix.graph.model.RegistryValue;
import helix.graph.model.impl.AbstractRegistry;
import helix.graph.util.EmptyIterable;

import java.util.Hashtable;


/**
 * In-Memory Registry for Graph, Vertex, Edge
 *
 */

public class MemRegistry extends AbstractRegistry {

	private static EmptyIterable<String> EmptyIterable_ = new EmptyIterable<String>();
	
	protected Hashtable<String, RegistryValue> map_ = null;
	
	private static final void checkKeyValue_(Object key, Object value) 
	  throws IllegalArgumentException {
		if (key == null)
			throw new IllegalArgumentException("null registry key");
		if (value == null)
			throw new IllegalArgumentException("null registry value");
	}

	public boolean has(String key) {
		checkKeyValue_(key, "");
		return (this.map_ == null  ? false : this.map_.containsKey(key));
	}

	public RegistryValue get(String key) {
		checkKeyValue_(key, "");
		return (this.map_ == null ? null : this.map_.get(key));
	}

	public void set(String key, RegistryValue value) {
		checkKeyValue_(key, value);
		if (this.map_ == null)
			this.map_ = new Hashtable<String, RegistryValue>(1);
		this.map_.put(key, value);
	}
	
	public void remove(String key) {
		checkKeyValue_(key, "");
		if (this.map_ != null)
			this.map_.remove(key);
	}

	public Iterable<String> keys() {
		return (this.map_ == null ?  EmptyIterable_ : map_.keySet());
	}

}
