package helix.graph.model.impl.memory;

import static org.junit.Assert.assertEquals;

import java.util.Set;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import helix.graph.model.GSet;
import helix.graph.model.Graph;
import helix.graph.model.Vertex;
import helix.graph.algo.ComponentsFinder;

public class TestComponents {

	private Graph g;
	private Vertex v1, v2, v3, v4, v5, v6, v7;

	/**
	 * Sets up the test fixture. 
	 * (Called before *every* test case method.)
	 */
	@Before
	public void initGraph() {
		g = new MemGraph();
		v1 = g.addVertex();
		v2 = g.addVertex();
		v3 = g.addVertex();
		v4 = g.addVertex();
		v5 = g.addVertex();
		v6 = g.addVertex();
		v7 = g.addVertex();
		v1.set("label", "v1");
		v2.set("label", "v2");
		v3.set("label", "v3");
		v4.set("label", "v4");
		v5.set("label", "v5");
		v6.set("label", "v6");
		v7.set("label", "v7");
		g.addEdge(v1, v2);
		g.addEdge(v2, v3);
		g.addEdge(v1, v3);
		g.addEdge(v1, v4);
		g.addEdge(v2, v5);
		g.addEdge(v6, v7);
	}

	/**
	 * Tears down the test fixture. 
	 * (Called after *every* test case method.)
	 */
	@After
	public void tearDown() {
	}

	/*
	 * Graph tests
	 */

	@Test
	public void testComponents() {
		ComponentsFinder cf = new ComponentsFinder(g);
		Set<GSet<Vertex>> partition = cf.connectedComponents();
		assertEquals("partition size", 2, partition.size());
		int min = 10;
		int max = 0;
		for (GSet<Vertex> clas : partition) {
			int siz = clas.size();
			if (siz < min) min = siz;
			if (siz > max) max = siz;
		}
		assertEquals("min size", 2, min);
		assertEquals("max size", 5, max);
	}

}
