package helix.graph.model.impl.memory;

import static org.junit.Assert.*;
import helix.graph.model.IllegalValueException;

import org.junit.Test;

public class TestMemRegistry {

	@Test
	public void testRegistry() {
		MemRegistry reg = new MemRegistry();
		reg.set("bool", true);
		reg.set("entier", 123);
		reg.set("float", 123f);
		reg.set("string", "123");
		assertEquals("registry test", 123, reg.get("entier").toInt());
		assertEquals("registry test", 123, reg.get("float").toInt());
		assertEquals("registry test", 123, reg.get("string").toInt());
		assertEquals("registry test", "123", reg.get("entier").toString());
		assertTrue(reg.get("float").toString().equals("123.0"));
		reg.set("float", 123.49999f);
		assertEquals("registry test", reg.get("float").toInt(), 123);
	}

	@Test
	public void testFlag() {
		MemRegistry reg = new MemRegistry();
		reg.set("flag");
		assertTrue(reg.has("flag"));
	}

	@Test(expected= IllegalValueException.class)
	public void testThrow1() {
		MemRegistry reg = new MemRegistry();
		reg.set("flag");
		assertEquals("throw exception", "foobar", reg.get("flag").toFloat());
	}
	
}
