package helix.graph.util;

import java.util.Iterator;

public abstract class AdaptedIterator<F, T> implements Iterator<T> {

	protected Iterator<F> iterator_;
	
	public AdaptedIterator (Iterator<F> iterator) {
		iterator_ = iterator;
	}

	public abstract T adapt(F f);

	public boolean hasNext() {
		return iterator_.hasNext();
	}

	public T next() {
		return this.adapt(iterator_.next());
	}

	public void remove() {
		iterator_.remove();
	}
}
