package helix.graph.util;

import java.util.BitSet;
import java.util.Iterator;
import java.util.NoSuchElementException;

public class BitSetIterator implements Iterator<Integer> {

	BitSet bitset_ = new BitSet();
	int current_ = 0;
	
	public BitSetIterator(BitSet b) {
		bitset_.or(b);
	}
	
	public boolean hasNext() {
		return (bitset_.nextSetBit(current_) >= 0);
	}

	public Integer next() throws NoSuchElementException {
		if (! hasNext())
			throw new NoSuchElementException();
		int pos = bitset_.nextSetBit(current_);
		current_ = pos + 1;
		return pos;
	}
	
	/**
	 * not implemented : throws UnsupportedOperationException
	 */
	public void remove() {
		throw new UnsupportedOperationException();
	}
}
