package helix.graph.util;

import java.io.PrintStream;
import java.util.logging.Logger;

/**
 * an abstract class to log and printout information
 */

public abstract class Reporter {
	
	protected static Logger logger_ = LogUtil.getLogger();
	protected static PrintStream printer_ = System.out;
	
	/**
	 * set Logger
	 */
	
	public static void setLogger(Logger logger) {
		logger_ = logger;
	}

	/**
	 * get logger verbosity
	 */
	public static boolean isVerbose() {
		return LogUtil.isVerbose(logger_);
	}
	
	/**
	 * log information (info level)
	 */
	
	public static void log(String msg) {
		logger_.info(msg);
	}

	/**
	 * log warning
	 */
	
	public static void warning(String msg) {
		logger_.warning("*Warning* " + msg + " [will be ignored]");
	}
	
	/**
	 * log severe error
	 */
	
	public static void severe(String msg) {
		logger_.severe("*Error* " + msg);
	}
	
	/**
	 * set Printer
	 */
	public static void setPrinter(PrintStream printer) {
		printer_ = printer;
	}

	/**
	 * print information
	 */
	
	public static void print(String msg) {
		printer_.print(msg);
	}

	public static void println(String msg) {
		printer_.println(msg);
	}
}
