package helix.graph.util;

import java.util.logging.Formatter;
import java.util.logging.LogRecord;

public class SimpleLogFormatter extends Formatter {

	protected String header_ = "+ ";

	public SimpleLogFormatter() {
		super();
	}
	
	public SimpleLogFormatter(String header) {
		super();
		header_ = header;
	}
	
	@Override
	public String format(LogRecord rec) {
		String msg = rec.getMessage();
		StringBuffer buf = new StringBuffer();
		if (msg == null) msg = "";
		for (String tok : msg.split("\n")) {
			buf.append(header_ + tok + "\n");
		}
		return buf.toString();
	}
	
	public void setHeader(String header) {
		header_ = header;
	}

	public String getHeader() {
		return header_;
	}

}
